extends RigidBody2D

onready var start = global_position#The starting position of the ball

var wallball = 5#If a ball is hit in such rapid succession, it's a wall ball and needs to be reseted

## Respawn
func newball():
	var newball = load("res://objects/ball.tscn").instance()
	name = "oldball"
	newball.name = "ball"
	newball.global_position = start
	get_parent().add_child(newball)
	queue_free()

## SOUND
func play_sound(s):#Plays a sound
	$sound.stream = load(s)
	$sound.play()

func ball_hit(bod):#when ever the ball is hit play some snappy sound effects... Also auto swap
	randomize()
	var playlist = [
		"res://assets/soundeffects/1_kick.wav",
		"res://assets/soundeffects/2_kickt.wav",
		"res://assets/soundeffects/3_hit.wav",
		"res://assets/soundeffects/4_hit.wav",
		"res://assets/soundeffects/5_bitcrush.wav",
		"res://assets/soundeffects/6_goal.wav",
		"res://assets/soundeffects/7_bounce.wav",
		"res://assets/soundeffects/8_ding.wav",
		"res://assets/soundeffects/9_grr.wav"
	]
	if(bod.get_parent().get_parent().name == "brazilplayers"):#add some hues
		playlist.append("res://assets/soundeffects/hue1.wav")
		playlist.append("res://assets/soundeffects/hue2.wav")
	if(bod.get_parent().get_parent().is_in_group("team")):#Oh and swap to newest character
		bod.get_parent().get_parent().swap_to(bod) 
	var r = randi()%playlist.size()
	if($sound.playing == true):#Hmmm this hasn't finished playing yet. Might be caught in wall
	## SEMI-HOTFIX
		wallball -= 1
		if(wallball < 0):#YEP it's a wallball
			newball()
	else:
		wallball = 5
	play_sound(playlist[r])

## ONLINE
slave func set_ball(pos):
	position = pos
	sleeping = true#Saves the ball pos, and stops integrate_forces from overriding the change.

## MAIN
master func _integrate_forces(state):
	if($AnimationPlayer.is_playing() == false):
		if(linear_velocity != Vector2(0,0)):
			$AnimationPlayer.play("roll")
		else:
			$AnimationPlayer.stop()
	
	if(get_tree().network_peer != null):
		if(get_network_master() == 1):#Server sends packet
			rpc("set_ball",position)

func _ready():
	connect("body_entered",self,"ball_hit")
#How can one change others?
#By changing oneself.