extends Node2D
#The basis for Player and AI
var is_home_team = false
var playerid = 1

var select_character = null
var characters = []

enum Samba_Mode {CHARGING,READY,SPENT}
var sambaready = Samba_Mode.CHARGING
export(int) var sambatime = 60 #At what time will samba be given

enum Stance_Mode {DEFENSIVE,MIDDLE,OFFENSIVE}#Tells the auto ai what positions to take up
var stance = Stance_Mode.MIDDLE

## SAMBA
func check_samba(tick):#let's see if samba is ready
	if(sambaready == Samba_Mode.CHARGING):
		if(tick < sambatime):
			sambaready = Samba_Mode.READY
			get_node("/root/hud").set_samba(is_home_team,100)
		else:
			var percentile = (100/abs(float(sambatime-120)))
			get_node("/root/hud").set_samba(is_home_team,percentile*-(tick-120))

master func samba():#Dance to the power of your nation's spirit
	get_node("/root/hud").sambatime(name,is_home_team)
	sambaready = Samba_Mode.SPENT
	match(name):
		"brazilplayers":#Speed up at half time
			for i in $players.get_children():
				i.tempboost(10,5)
		"spainplayers":#Speed up after 3 goals
			for i in $players.get_children():
				i.tempboost(5,6)
		"britishplayers":
			for i in $players.get_children():
				i.tempboost(5,5)
		"italianplayers":
			for i in $players.get_children():
				i.tempboost(3,20)
		"russianplayers":
			for i in $players.get_children():
				i.tempboost(7,4)
		"japanplayers":
			for i in $players.get_children():
				i.tempboost(17,20)
		"ausieplayers":
			get_node("/root/hud").score_goal("Australia")
			get_node("/root/hud").score_goal("Australia")
			for i in $players.get_children():
				i.tempboost(2,3)
		"americanplayers":#Welcome to the land of the free partner
			for i in $players.get_children():
				i.tempboost(20,2)
		"argentinaplayers":#Best friends.. er enemies?
			for i in $players.get_children():
				i.tempboost(4,7)
		"irishplayers":
			for i in $players.get_children():
				i.tempboost(4,7)
		"frenchplayers":
			for i in $players.get_children():
				i.tempboost(3,4)
		"swedishplayers":
			for i in $players.get_children():
				i.tempboost(3,14)
		"polishplayers":
			for i in $players.get_children():
				i.tempboost(7,3)
		"saudiplayers":
			for i in $players.get_children():
				i.tempboost(8,2)
		"candianplayers":
			for i in $players.get_children():
				i.tempboost(5,5)
		"bearplayer":
			for i in $players.get_children():
				i.tempboost(6,7)
	
	if(is_network_master()):
		rpc("update_samba")

## TEAM MANAGEMENT
func remove_hightlighter(): #REMOVE OLD HIGHLIGHTING
	if(is_instance_valid(select_character)):
		if(select_character.has_node("highlight")):
			select_character.get_node("highlight").queue_free()
			select_character.get_node("highlight").name = "deletion"

func add_hightlighter():#Adds highlighting to newest character
	var hight = load("res://assets/particles/CPUPARTICLES_highlighter.tscn").instance()
	hight.name = "highlight"
	select_character.add_child(hight)

master func swap():#swap to the next character
	remove_hightlighter()
	select_character = characters[0]
	add_hightlighter()
	#push front character to the back
	characters.append(characters[0])
	characters.remove(0)

	if(is_network_master()):
		rpc("update_swap")

func swap_to(newchar):#Swaps to a specified character\
	remove_hightlighter()
	select_character = newchar
	add_hightlighter()

func set_home_team():#Sets this player/team as the home team
	$Navigation2D.scale.x = -1
	$Navigation2D.position.x = 256
	is_home_team = true
	playerid = 2

func change_stance(bod,newstance):#move the stance based on ball's location
	if(bod.name == "ball"):
		stance = newstance
		print_debug(Stance_Mode[Stance_Mode.keys()[stance]])

## ONLINE
slave func update_samba():
	samba()

slave func update_swap():
	swap()

## MAIN
func _ready():
	get_node("/root/hud").connect("sambacheck",self,"check_samba")
	if(name == "americanplayers"):#Americans are such patriots
		get_node("/root/hud/music").stream = load("res://assets/music/yankeedoodle.ogg")
		get_node("/root/hud/music").play()

	for child in $players.get_children():
		characters.append(child)
	swap()
#Fear can drive us to do things, and it can stop us
#The fear of God will premote good, and stop evil.
#The fear of man will see envy in good light, and prevent kindness.