extends CanvasLayer

enum Modes {SINGLEPLAYER,LOCAL,ONLINE}
var multiplayermode = Modes.LOCAL
var clientnum = 10

var brazilteamgoals = 0
var otherteamgoals = 0

var tick = 120

signal sambacheck(tick)
## SAMBA TIME
func load_samba(is_home_side,what):
	$music.stream = load(what)
	if(is_home_side == true):
		$sambaother.value = 0
		$sambaother.texture_over = load("res://assets/display/right_active.png")
		$sambaother/CPUParticles2D.emitting = true
	else:
		$sambabrazil.value = 0
		$sambabrazil.texture_over = load("res://assets/display/left_active.png")
		$sambabrazil/CPUParticles2D.emitting = true

func sambatime(who,is_home_side):#A side has activated samba
	if(who.find("@") != -1):#Make sure to get the key word
		who = who.substr(1,who.find_last("@")-1)
		print_debug(who)
	match(who):
		"brazilplayers":
			load_samba(is_home_side,"res://assets/music/SambaDoBrazil.ogg")
		"spainplayers":
			load_samba(is_home_side,"res://assets/music/fiesta.ogg")
		"britishplayers":
			load_samba(is_home_side,"res://assets/music/RULEBRIT.ogg")
		"italianplayers":
			load_samba(is_home_side,"res://assets/music/papacy.ogg")
		"russianplayers":
			load_samba(is_home_side,"res://assets/music/sahbr.ogg")
		"japanplayers":
			load_samba(is_home_side,"res://assets/music/weebvoc.ogg")
		"ausieplayers":
			load_samba(is_home_side,"res://assets/music/arbongonnslidieislueeeee.ogg")
		"americanplayers":
			load_samba(is_home_side,"res://assets/music/cottoneyedjoe.ogg")
		"argentinaplayers":
			load_samba(is_home_side,"res://assets/music/File Por_una_cabeza_carlos_gardel.ogg")
		"irishplayers":
			load_samba(is_home_side,"res://assets/music/Irish Rebel Song- Come Out ye Black and Tans.ogg")
		"frenchplayers":
			load_samba(is_home_side,"res://assets/music/Emile_Vacher_-_Mado_-_French_Musette.ogg")
		"swedishplayers":
			load_samba(is_home_side,"res://assets/music/United_States_Navy_Band_-_Sweden.ogg")
		"polishplayers":
			load_samba(is_home_side,"res://assets/music/marchmarchdabroski.ogg")
		"saudiplayers":
			load_samba(is_home_side,"res://assets/music/The National Anthem of the Kingdom of Saudi Arabia.ogg")
		"candianplayers":
			load_samba(is_home_side,"res://assets/music/The Mountie - Entrance Theme.ogg")
		"bearplayer":
			load_samba(is_home_side,"res://assets/music/Winnie The Pooh - Theme Intro Song.ogg")
	$music.play()

func set_samba(is_home_team,val):#the display will match how much samba this play has accumilated
	if(is_home_team == false):
		$sambabrazil.value = val
	else:
		$sambaother.value = val

## SCORING
func score_goal(who):
	if(who == "Brazil"):
		brazilteamgoals += 1
	else:
		otherteamgoals += 1
	$score.text = str(brazilteamgoals)+"|"+str(otherteamgoals)
	crowd_cheers()

func crowd_cheers():#The crowd goes wild
	var playlist = [
		"res://assets/soundeffects/1_crowd.wav",
		"res://assets/soundeffects/2_crowd.wav",
		"res://assets/soundeffects/3_crowd.wav",
		"res://assets/soundeffects/4_crowd.wav",
		"res://assets/soundeffects/5_crowd.wav",
		"res://assets/soundeffects/6_crowd.wav",
		"res://assets/soundeffects/7_crowd.wav",
		"res://assets/soundeffects/8_crowdlong.wav",
		"res://assets/soundeffects/9_crowdlong.wav"
	]
	var select_cheer = randi()%playlist.size()
	$crowd.stream = load(playlist[select_cheer])
	$crowd.play()

## END OF MATCH
func sudden_death():#When the match has a tie start sudden death
	lost()#For now it's counted as a lost

func lost():#Lost the match
	$cutscenes.play("lost")
	$transition.visible = true
	get_tree().paused = true

func won(who):#NEXT match
	$music.stream = load("res://assets/music/Samba2.ogg")
	$music.play()
	$transition.visible = true
	get_tree().paused = true
	if(multiplayermode == Modes.SINGLEPLAYER):
		match(get_tree().get_root().get_child(1).name):#What is the current field
			"argentinafield":#Just beaten argentina
				$cutscenes.play("beatargentina")
			"pier":
				$cutscenes.play("beatireland")
			"frenchfield":
				$cutscenes.play("beatfrance")
			"swedenfield":
				$cutscenes.play("beatsweden")
			"polandfield":
				$cutscenes.play("beatpoland")
			"dessert":
				$cutscenes.play("beatsaudi")
			"hockeyring":
				$cutscenes.play("beatcanada")
			"forest":
				$cutscenes.play("beatbear")
	else:#NEEDS MATCH AND FILLED OUT
		match(who):
			"brazilplayers":
				$cutscenes.play("wonbrazil")
			"britishplayers":
				$cutscenes.play("wonbritish")
			"spainplayers":
				$cutscenes.play("wonspain")
			"italianplayers":
				$cutscenes.play("wonitaly")
			"russianplayers":
				$cutscenes.play("wonrussia")
			"japanplayers":
				$cutscenes.play("wonjapan")
			"ausieplayers":
				$cutscenes.play("wonausie")
			"americanplayers":
				$cutscenes.play("wonamerica")
			"argentinaplayers":
				$cutscenes.play("wonargentina")
			"irishplayers":
				$cutscenes.play("wonireland")
			"frenchplayers":
				$cutscenes.play("wonfrance")
			"swedishplayers":
				$cutscenes.play("wonsweden")
			"polishplayers":
				$cutscenes.play("wonpoland")
			"saudiplayers":
				$cutscenes.play("wonsaudi")
			"candianplayers":
				$cutscenes.play("woncanada")
			"bearplayer":
				$cutscenes.play("wonbear")

func cutscene_done(anime):#The current scene has finished playing
	print_debug(anime)
	if(multiplayermode == Modes.SINGLEPLAYER):
		match(anime):
			"lost","beatbear":#Sad man/ yay you won
				toggle_menu()
			"beatargentina":#load irish
				start_game(load("res://levels/pier.tscn").instance(),"res://objects/irishplayers.tscn","res://objects/brazilplayers.tscn")
			"beatireland":#load cowards
				start_game(load("res://levels/frenchfield.tscn").instance(),"res://objects/frenchplayers.tscn","res://objects/brazilplayers.tscn")
			"beatfrance":#load sodomites
				start_game(load("res://levels/swedenfield.tscn").instance(),"res://objects/swedishplayers.tscn","res://objects/brazilplayers.tscn")
			"beatsweden":#load slavs
				start_game(load("res://levels/polandfield.tscn").instance(),"res://objects/polishplayers.tscn","res://objects/brazilplayers.tscn")
			"beatpoland":#load magnates
				start_game(load("res://levels/dessert.tscn").instance(),"res://objects/saudiplayers.tscn","res://objects/brazilplayers.tscn")
			"beatsaudi":#load leaf
				start_game(load("res://levels/hockeyring.tscn").instance(),"res://objects/candianplayers.tscn","res://objects/brazilplayers.tscn")
			"beatcanada":#load the bear
				start_game(load("res://levels/forest.tscn").instance(),"res://objects/bearplayer.tscn","res://objects/brazilplayers.tscn")
	else:
		toggle_menu()
	reset_hud()

## Interactivity
func toggle_pause(forcepause = null):#Stops the hud, or resumes it
	if(forcepause == null):
		if(get_node("timer/Timer").paused == true):
			get_node("timer/Timer").paused = false
		else:
			get_node("timer/Timer").paused = true
	else:
		get_node("timer/Timer").paused = forcepause
	$score.visible = !$timer/Timer.paused
	$timer.visible = !$timer/Timer.paused
	$sambabrazil.visible = !$timer/Timer.paused
	$sambaother.visible = !$timer/Timer.paused
	layer = int(!$timer/Timer.paused)
	if(layer == 0):
		layer = -1

func reset_hud():#RESET HUD
	$transition.visible = false
	get_tree().paused = false
	tick = 120
	$timer/Timer.start()
	$sambabrazil.texture_over = null
	$sambaother.texture_over = null
	$sambabrazil/CPUParticles2D.emitting = false
	$sambaother/CPUParticles2D.emitting = false
	brazilteamgoals = 0
	otherteamgoals = 0
	$score.text = "0 | 0"

func hud_transperency(bod,val):#When ever the ball enters the hud's line of sight, make it transparent
	if(bod.name == "ball"):
		$score.modulate.a = val
		$timer.modulate.a = val
		$sambabrazil.modulate.a = val
		$sambaother.modulate.a = val

## GAME START
func start_game(field,home,visit):
	print_debug(get_node("/root/hud").Modes.keys()[get_node("/root/hud").multiplayermode])
	clear_fields()#Erase the previous field

	var hommies = load(home).instance()
	var carrysambahotfix = hommies.sambatime#HOTFIX since the script is reseted, so will the samba time (AKA all will have 60 ticks til samba.) This carries the sambatime even when the script is reseted
	if(multiplayermode == Modes.SINGLEPLAYER):
		hommies.set_script(load("res://scripts/AI.gd"))
	else:
		hommies.set_script(load("res://scripts/player.gd"))
	hommies.set_home_team()
	hommies.sambatime = carrysambahotfix

	var vistors = load(visit).instance()
	carrysambahotfix = vistors.sambatime
	vistors.set_script(load("res://scripts/player.gd"))
	vistors.sambatime = carrysambahotfix

	if(get_tree().network_peer != null):
		hommies.set_network_master(1)
		hommies.playerid = 1
		vistors.set_network_master(clientnum)

	field.add_child(hommies)
	field.add_child(vistors)
	get_tree().root.add_child(field)
	toggle_pause(false)

func toggle_menu():#Toggles the menu.tscn
	if(!get_tree().root.has_node("menu")):
		get_tree().root.add_child(load("res://GUI/menu.tscn").instance())
		clear_fields()
	else:
		get_tree().root.get_node("menu").queue_free()

func clear_fields():#Gets rid of any fields that have been spawned
	for i in get_tree().root.get_children():
		if(i.get_class() == "Node2D"):#It's a field erase
			i.queue_free()

## MAIN
func newtick(val):#The counter is ticking
	tick = val
	$timer.text = str(tick)
	emit_signal("sambacheck",tick)#For timebased sambas

	if(tick == 0):#END OF MATCH
		if(multiplayermode == Modes.SINGLEPLAYER):
			if(brazilteamgoals == otherteamgoals):#Uh oh a tie
				sudden_death()
			elif(brazilteamgoals > otherteamgoals):#Brazilians won
				won("brazilplayers")
			elif(brazilteamgoals < otherteamgoals):#Brazilians lost
				lost()
		else:
			var con = get_signal_connection_list("sambacheck")
			if(con.size() > 1):
				var teamwon = ""
				var hometeam = con[0]["target"]
				var visitteam = con[1]["target"]
				if(brazilteamgoals > otherteamgoals):
					teamwon = visitteam.name
				else:#A tie equals hometeam win
					teamwon = hometeam.name
				if(teamwon.find("@") != -1):
					teamwon = teamwon.substr(1,teamwon.find_last("@")-1)
				won(teamwon)
			else:
				won("brazilplayers")

func _physics_process(delta):
	if(int($timer/Timer.time_left) < tick):
		newtick(int($timer/Timer.time_left))

func _input(event):
	if(event.is_action_pressed("ui_cancel")):#Loads up menu
		toggle_menu()

func _ready():
	crowd_cheers()

	$transparentbox.connect("body_entered",self,"hud_transperency",[0.3])
	$transparentbox.connect("body_exited",self,"hud_transperency",[1])

	$cutscenes.connect("animation_finished",self,"cutscene_done")

#Galatians 5:22-24
#22 But the fruit of the Spirit is love, joy, peace, longsuffering,
#gentleness, goodness, faith,
#23 Meekness, temperance: against such there is no law.
#24 And they that are Christ’s have crucified the flesh with the
#affections and lusts.