extends ItemList

var knownservers = {
	"localhost":"127.0.0.1"
}

## KNOWN SERVERS
func save_servers():
	knownservers[$server.text] = $server.text
	var f = File.new()
	f.open("res://servers.json",f.WRITE)
	f.store_string(to_json(knownservers))
	f.close()

func load_servers():
	var f = File.new()
	if(f.file_exists("res://servers.json")):
		f.open("res://servers.json",f.READ)
		var content = f.get_as_text()
		var jparse = JSON.parse(content)
		if(jparse.error == OK):
			knownservers = jparse.result
		if(f.get_len() > 12000):
			for i in range(10):
				knownservers.erase(knownservers.keys()[i])
		f.close()
	for serv in knownservers:
		add_item(serv)

func select_server(idx):#Selected a server from the menu
	$server.text = get_item_text(idx)
## CONNECTION
func host_game():
	var serv = NetworkedMultiplayerENet.new()
	serv.create_server(int($port.text),2)
	get_tree().network_peer = serv
	get_tree().root.add_child(load("res://GUI/teamselect.tscn").instance())
	queue_free()

func connect_game():
	var serv = NetworkedMultiplayerENet.new()
	serv.create_client($server.text,int($port.text))
	get_tree().network_peer = serv
	get_tree().root.add_child(load("res://GUI/teamselect.tscn").instance())
	if(!knownservers.has($server.text)):#Hey this was unknown, let's save it
		save_servers()
		print("yeah")
	queue_free()

## MAIN
func _ready():
	$server.text = str(IP.get_local_addresses()[0])
	$join.connect("pressed",self,"connect_game")
	$host.connect("pressed",self,"host_game")
	connect("item_selected",self,"select_server")
	load_servers()