extends VSplitContainer
var hometeam = "res://assets/graphical_interfact/spainflag.png"
var opposingteam = "res://assets/graphical_interfact/brazilflag.png"

var is_selecting_home = false

## Selection
master func selectteam(who):# a team has been selected update data
	if(get_tree().network_peer != null):
#		print_debug(get_tree().network_peer.get_unique_id())
		if(get_tree().network_peer.get_unique_id() == 1):#HOST gets home team
			rpc("update_select_team",who.resource_path,true)
		else:
			rpc("update_select_team",who.resource_path,false)
	else:
		if(is_selecting_home == true):
			hometeam = who.resource_path
			$facing/team2.texture = who
			is_selecting_home = false
		else:
			opposingteam = who.resource_path
			$facing/team1.texture = who
			is_selecting_home = true

sync func update_select_team(who,side):
	if(side == true):
		$facing/team2.texture = load(who)#You can't send TexturePaths over a connection,,, but you can send the texture itself?
		hometeam = who
	else:
		$facing/team1.texture = load(who)
		opposingteam = who

func teamscene(who):
	match(who):
		"res://assets/graphical_interfact/brazilflag.png":
			return "res://objects/brazilplayers.tscn"
		"res://assets/graphical_interfact/spainflag.png":
			return "res://objects/spainplayers.tscn"
		"res://assets/graphical_interfact/ukflag.png":
			return "res://objects/britishplayers.tscn"
		"res://assets/graphical_interfact/italyflag.png":
			return "res://objects/italianplayers.tscn"
		"res://assets/graphical_interfact/russiaflag.png":
			return "res://objects/russianplayers.tscn"
		"res://assets/graphical_interfact/japanflag.png":
			return "res://objects/japanplayers.tscn"
		"res://assets/graphical_interfact/austrialliaflag.png":
			return "res://objects/ausieplayers.tscn"
		"res://assets/graphical_interfact/americaflag.png":
			return "res://objects/americanplayers.tscn"
		"res://assets/graphical_interfact/argentinaflag.png":
			return "res://objects/argentinaplayers.tscn"
		"res://assets/graphical_interfact/irelandflag.png":
			return "res://objects/irishplayers.tscn"
		"res://assets/graphical_interfact/frenchflag.png":
			return "res://objects/frenchplayers.tscn"
		"res://assets/graphical_interfact/swedenflag.png":
			return "res://objects/swedishplayers.tscn"
		"res://assets/graphical_interfact/polandflag.png":
			return "res://objects/polishplayers.tscn"
		"res://assets/graphical_interfact/saudiflag.png":
			return "res://objects/saudiplayers.tscn"
		"res://assets/graphical_interfact/canadaflag.png":
			return "res://objects/candianplayers.tscn"
		"res://assets/graphical_interfact/bearflag.png":
			return "res://objects/bearplayer.tscn"

## ONLINE
func connection_failed():
	print_debug("Failed to connect")
	queue_free()

func connection_succeeded():
	print_debug("Connection established")
	get_node("/root/hud").clientnum = get_tree().network_peer.get_unique_id()

func peer_connected(id):
	print_debug("client connected: ",id)
	get_node("/root/hud").clientnum = id
	if(get_tree().network_peer.get_unique_id() == 1):
		$facing/play.disabled = false
		$facing/play.modulate.a = 1
		rpc("update_select_team",$facing/team2.texture.resource_path,true)

func peer_disconnected(id):
	print_debug("client disconnected: ",id)
	$facing/play.disabled = true
	$facing/play.modulate.a = 0.5

func server_disconnected():
	print_debug("Lost Host")
	queue_free()

## SIGNALS
func _on_item_select(idx):#A team selected
	selectteam($teamlist.get_item_icon(idx))

func play_game():
	if(get_tree().network_peer == null):
		start_game()
	else:
		rpc("start_game")

## START
sync func start_game():
	get_node("/root/hud").multiplayermode = get_node("/root/hud").Modes.LOCAL
	var newscene = null
	match(hometeam):#The home team determines the field
		"res://assets/graphical_interfact/brazilflag.png":
			newscene = load("res://levels/brazilfield.tscn").instance()
		"res://assets/graphical_interfact/spainflag.png":
			newscene = load("res://levels/spainfield.tscn").instance()
		"res://assets/graphical_interfact/ukflag.png":
			newscene = load("res://levels/britishstadium.tscn").instance()
		"res://assets/graphical_interfact/italyflag.png":
			newscene = load("res://levels/italycol.tscn").instance()
		"res://assets/graphical_interfact/russiaflag.png":
			newscene = load("res://levels/winter.tscn").instance()
		"res://assets/graphical_interfact/japanflag.png":
			newscene = load("res://levels/japstad.tscn").instance()
		"res://assets/graphical_interfact/austrialliaflag.png":
			newscene = load("res://levels/outback.tscn").instance()
		"res://assets/graphical_interfact/americaflag.png":
			newscene = load("res://levels/americanfield.tscn").instance()
		"res://assets/graphical_interfact/argentinaflag.png":
			newscene = load("res://levels/argentinafield.tscn").instance()
		"res://assets/graphical_interfact/irelandflag.png":
			newscene = load("res://levels/pier.tscn").instance()
		"res://assets/graphical_interfact/frenchflag.png":
			newscene = load("res://levels/frenchfield.tscn").instance()
		"res://assets/graphical_interfact/swedenflag.png":
			newscene = load("res://levels/swedenfield.tscn").instance()
		"res://assets/graphical_interfact/polandflag.png":
			newscene = load("res://levels/polandfield.tscn").instance()
		"res://assets/graphical_interfact/saudiflag.png":
			newscene = load("res://levels/dessert.tscn").instance()
		"res://assets/graphical_interfact/canadaflag.png":
			newscene = load("res://levels/hockeyring.tscn").instance()
		"res://assets/graphical_interfact/bearflag.png":
			newscene = load("res://levels/forest.tscn").instance()

	if(get_tree().network_peer == null):#Don't do this online
		if($facing/team2/cpu.pressed == true):
			get_node("/root/hud").multiplayermode = get_node("/root/hud").Modes.SINGLEPLAYER
		else:
			get_node("/root/hud").multiplayermode = get_node("/root/hud").Modes.LOCAL
	get_node("/root/hud").start_game(newscene,teamscene(hometeam),teamscene(opposingteam))
	queue_free()

## MAIN
func _ready():
	$teamlist.connect("item_selected",self,"_on_item_select")
	$facing/play.connect("pressed",self,"play_game")
	$facing/team2/cpu.connect("pressed",self,"cpu_toggled")
	var net = get_tree().network_peer
	if(net != null):
		$facing/play.disabled = true
		$facing/play.modulate.a = 0.5
		net.connect("connection_failed",self,"connection_failed")
		net.connect("connection_succeeded",self,"connection_succeeded")
		net.connect("peer_connected",self,"peer_connected")
		net.connect("peer_disconnected",self,"peer_disconnected")
		net.connect("server_disconnected",self,"server_disconnected")